## Class ClassPropertiesWindow

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Dialog
        - - javax.swing.JDialog
          - - ClassPropertiesWindow

All Implemented Interfaces:
  java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, javax.swing.RootPaneContainer, javax.swing.WindowConstants

    public class ClassPropertiesWindow
    extends javax.swing.JDialog

Classe permettant la création de fenêtres pour la modification des propriétés des classes.

Author:
  V.BOULANGER
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JDialog

`javax.swing.JDialog.AccessibleJDialog`

### Nested classes/interfaces inherited from class java.awt.Dialog

`java.awt.Dialog.AccessibleAWTDialog, java.awt.Dialog.ModalExclusionType, java.awt.Dialog.ModalityType`

### Nested classes/interfaces inherited from class java.awt.Window

`java.awt.Window.AccessibleAWTWindow, java.awt.Window.Type`

### Nested classes/interfaces inherited from class java.awt.Container

`java.awt.Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

### Field Summary

Fields
`static int` `UPDATE_ATTR`
`static int` `UPDATE_METH`

### Fields inherited from class javax.swing.JDialog

`accessibleContext, rootPane, rootPaneCheckingEnabled`

### Fields inherited from class java.awt.Dialog

`DEFAULT_MODALITY_TYPE`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface javax.swing.WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`ClassPropertiesWindow(UmlDiagram umlDiagram, Class a)` Constructeur - Crée une instance de la fenêtre de propriétés de classe à partir d'un diagramme et de la classe à modifier.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addAttribute()` Ajoute un attribut à la classe et rafraîchit la liste des attributs.
`void` `addMethod()` Ajoute une méthode à la classe et rafraîchit la liste des méthodes.
`void` `addMethod(int index, Method m)` Ajoute une méthode à la classe et rafraîchit la liste des méthodes.
`void` `defineMainClass(Class a)`
`Class` `getEditingClass()` Récupère la classe en cours d'édition.
`void` `listAttributes()` Affiche la liste des attributs de la classe dans le tableau
`void` `listMethods()` Affiche la liste des méthodes de la classe dans le tableau.
`void` `openArgumentsWindow(Method m)` Ouvre une fenêtre d'édition des arguments pour la méthode sélectionnée
`void` `overloadMethod()` On surcharge la méthode avec un argument en plus qui peut être modifié par la suite.
`void` `refreshGraphics()` Rafraîchit la classe graphiquement.
`void` `removeAttribute()` Retire un attribut à la classe et rafraîchit la liste des attributs.
`void` `removeMethod()` Retire une méthode à la classe et rafraîchit la liste des méthodes.
`void` `saveAttributes()` Sauvegarde les attributs pour la classe en cours.
`void` `saveClass()` Sauvegarde l'ensemble de la classe.
`void` `saveMethods()` Sauvegarde les méthodes pour la classe en cours.

### Methods inherited from class javax.swing.JDialog

`addImpl, createRootPane, dialogInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

### Methods inherited from class java.awt.Dialog

`addNotify, getModalityType, getTitle, hide, isModal, isResizable, isUndecorated, setBackground, setModal, setModalityType, setOpacity, setResizable, setShape, setTitle, setUndecorated, setVisible, show, toBack`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### UPDATE_ATTR

    public static final int UPDATE_ATTR

See Also:
  Constant Field Values

#### UPDATE_METH

    public static final int UPDATE_METH

See Also:
  Constant Field Values

### Constructor Detail

#### ClassPropertiesWindow

    public ClassPropertiesWindow(UmlDiagram umlDiagram,
                                 Class a)

Constructeur - Crée une instance de la fenêtre de propriétés de classe à partir d'un diagramme et de la classe à modifier.

Parameters:
  `umlDiagram` - Le diagramme qui contient la classe.
  `a` - La classe à modifier.

### Method Detail

#### defineMainClass

    public void defineMainClass(Class a)

#### openArgumentsWindow

    public void openArgumentsWindow(Method m)

Ouvre une fenêtre d'édition des arguments pour la méthode sélectionnée

Parameters:
  `m` - La méthode dans laquelle seront modifiés les arguments.

#### getEditingClass

    public Class getEditingClass()

Récupère la classe en cours d'édition.

Returns:
  La classe en cours d'édition.

#### addAttribute

    public void addAttribute()

Ajoute un attribut à la classe et rafraîchit la liste des attributs.

#### removeAttribute

    public void removeAttribute()

Retire un attribut à la classe et rafraîchit la liste des attributs.

#### addMethod

    public void addMethod()

Ajoute une méthode à la classe et rafraîchit la liste des méthodes.

#### addMethod

    public void addMethod(int index,
                          Method m)

Ajoute une méthode à la classe et rafraîchit la liste des méthodes.

Parameters:
  `index` - Le rang d'insertion de la méthode.
  `m` - La méthode à insérer.

#### removeMethod

    public void removeMethod()

Retire une méthode à la classe et rafraîchit la liste des méthodes.

#### overloadMethod

    public void overloadMethod()

On surcharge la méthode avec un argument en plus qui peut être modifié par la suite.

#### listAttributes

    public void listAttributes()

Affiche la liste des attributs de la classe dans le tableau

#### listMethods

    public void listMethods()

Affiche la liste des méthodes de la classe dans le tableau.

#### saveAttributes

    public void saveAttributes()

Sauvegarde les attributs pour la classe en cours.

#### saveMethods

    public void saveMethods()

Sauvegarde les méthodes pour la classe en cours.

#### saveClass

    public void saveClass()

Sauvegarde l'ensemble de la classe.

#### refreshGraphics

    public void refreshGraphics()

Rafraîchit la classe graphiquement.